﻿<%
/*
	本文件是前后台通用的一些全局函数
*/

;(function(){
/* 数字格式化，不需要了，直接用 Number(变量).toFixed(小数点后位数)就可以了 */
//	formatNummber = function(src, pos){
//		if(isNaN(src))src=0.0;
//		var v=Math.round(src*Math.pow(10, pos))/Math.pow(10, pos);
//		if(v.toString().indexOf(".")==-1) v += ".0";
//		return v;
//	};

	/* 生成范围为1-max的随机数 */
	rndnum = function(max) { return Math.floor(Math.random()*max+1) };

	/*
		获得当前日期的中国星期序号（周一至周日分别为1-7而不是1-6和0）
		加6模7，即可将周日调到周六的后面，此时周一至周日为0-6
		直接取昨天的星期序号+1也可得到该结果，但比这个更麻烦
		如果需要返回中文的星期名称用：return "星期"+"天一二三四五六".charAt(new Date().getDay());
	*/
	GetWeekNo = function() { return (new Date().getDay()+6) % 7 + 1 };

	/* 字母和数据库中字母对应的id之间的转换，如果传入A则返回1，传入4则返回D */
	Letter2Id = function(LetterOrId){
		var letters = "_ABCDEFGHIJKLMNOPQRSTUVWXYZ";//前面多个_号是因为数据库中用1表示字母A
		if(isNaN(LetterOrId)) return letters.indexOf(LetterOrId.toUpperCase());//也可以用LetterOrId.toUpperCase().charCodeAt()-64
		else return letters.charAt(LetterOrId);//也可以用String.fromCharCode(64+LetterOrId)
	};

	/* 格式化显示日期时间 x:待显示的日期时间，可以为数字形式 y:需要显示的格式，例如yyyy-MM-dd hh:mm:ss */
	date2str = function(x,y) {
		x = t_cdate(x);//保证x是日期类型(时间戳或UTC字符串转日期)
		if(!y) y = "yyyy-MM-dd hh:mm:ss";
		var z = {y:x.getFullYear(),M:x.getMonth()+1,d:x.getDate(),h:x.getHours(),m:x.getMinutes(),s:x.getSeconds()};
		return y.replace(/(y+|M+|d+|h+|m+|s+)/g,function(v) {return ((v.length>1?"0":"")+eval('z.'+v.slice(-1))).slice(-(v.length>2?v.length:2))});
	};

	// 任意对象转字符串
	t_cstr = function(obj){ return String(obj || "") };
	// 任意对象转整型
	t_cint = function(obj){ return isNaN(parseInt(obj,10)) ? 0 : parseInt(obj,10) };
	// 任意对象转日期
	t_cdate = function(obj){
		if(typeof obj=="obj") return obj;//已经是日期
		else if(!isNaN(obj)) return new Date(eval(obj));//数字或数字字符串转日期
		else if(!isNaN(Date.parse(obj))) return new Date(Date.parse(obj));//UTC格式字符串转日期
		else return new Date();//null,undefined,0,"" 均返回当前时间
	};
	/* 
		将中文数字转为阿拉伯数字
		cleft和cright分别为正则限定字符，防止“千山万水”被替换为“1000山10000水”
		使用方法：t_cArab("第一千零叁十五章 千山万水","第","章")  返回“第1035章 千山万水”
	*/
	t_cArab = function(obj,cleft,cright){
		var cnNum="〇一二三四五六七八九十百千万亿零壹贰叁肆伍陆柒捌玖拾佰仟萬億";
		var Arab = ["+0","+1","+2","+3","+4","+5","+6","+7","+8","+9","0","00","000","0000","00000000"];
		cleft = cleft || "";
		cright = cright || "";
		return obj.replace(new RegExp(cleft+"(["+cnNum+"]+)"+cright,"g"),function(a,b){
			var tmpstr = "";
			for(i in b)tmpstr+=Arab[cnNum.indexOf(b[i])%15];
			return cleft+eval(tmpstr.replace(/(^0|\+00)/g,"+10"))+cright;//修复十三或一千零十三的错误
		});
	};
	/*
		根据数字id生成文件路径，补齐至9位后每3位数字一级目录
		例如：id为12345，则文件路径为000/012/345
	*/
	GetPathById = function (id)
	{
		var id = ((id || 0) + "").padLeft("0", 9), result = '';
		while (id.length > 3)
		{
			result = '/' + id.slice(-3) + result;
			id = id.slice(0, id.length - 3);
		}
		if (id) { result = id + result; }
		return result;
	};
	/*
		将后端最新章节信息切割为id和name，以json返回
	*/
	GetLastChapter = function(str){
		str = t_cstr(str);
		if(str.contain("$$$")){
			var _tmparr = str.split("$$$")
			return {"id":_tmparr[0],"name":_tmparr[1]};
		} else {
			return {"id":"","name":""};
		}
	};
	/*
		将浮点数评分转换为保留1位小数的评分
	*/
	GetFixedScore = function(score){
		return Number(t_cint(score)/10).toFixed(1);
	};
}());
%>